"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = TestSelect;
const react_1 = __importDefault(require("react"));
const components_1 = require("@storybook/components");
const theming_1 = require("@storybook/theming");
const utils_js_1 = require("../utils.js");
const LinkIconContainer = theming_1.styled.span(({ theme }) => ({
    display: 'inline-block',
    width: '20px',
    color: theme.color.defaultText,
    textAlign: 'center',
}));
function TestSelect(props) {
    const testName = props.tests.find((x) => x.id === props.selectedTestId)?.testName ?? '';
    return (react_1.default.createElement(components_1.WithTooltip, { trigger: "click", placement: "bottom", closeOnClick: true, tooltip: ({ onHide }) => (react_1.default.createElement(components_1.TooltipLinkList, { links: props.tests.map((x) => ({
                id: x.id,
                title: x.testName ?? '',
                active: props.selectedTestId === x.id,
                onClick: () => {
                    props.onChangeTest(x.id);
                    onHide();
                },
                left: react_1.default.createElement(LinkIconContainer, null, (0, utils_js_1.getEmojiByTestStatus)(x.status, x.skip)),
            })) })) },
        react_1.default.createElement(components_1.Button, { outline: true, small: true },
            react_1.default.createElement(components_1.Icons, { icon: "menu" }),
            testName)));
}
//# sourceMappingURL=TestSelect.js.map