"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PageHeader = PageHeader;
const react_1 = __importStar(require("react"));
const components_1 = require("@storybook/components");
const theming_1 = require("@storybook/theming");
const helpers_js_1 = require("../../helpers.js");
const ImagePreview_js_1 = require("./ImagePreview.js");
const viewMode_js_1 = require("../../viewMode.js");
const Container = theming_1.styled.div({
    margin: '24px 44px 0',
});
const ErrorContainer = (0, theming_1.withTheme)(theming_1.styled.div(({ theme }) => ({
    marginTop: '8px',
    padding: '8px',
    background: theme.background.negative,
    color: theme.color.negative,
    borderRadius: '2px',
    display: 'flex',
    alignItems: 'baseline',
    '& svg': {
        margin: '0 5px',
        width: 8,
        height: 8,
    },
    '& pre': {
        margin: '0 4px',
        padding: 0,
        lineHeight: '22px',
    },
})));
const H1 = theming_1.styled.h1({
    margin: 0,
    marginBottom: '8px',
});
const HeaderDivider = (0, theming_1.withTheme)(theming_1.styled.span(({ theme }) => ({
    padding: '0 8px',
    color: theme.color.mediumdark,
})));
const ImagesEntriesContainer = theming_1.styled.div({
    display: 'flex',
    margin: '16px 0 8px',
});
function PageHeader({ title, images = {}, errorMessage, showViewModes, showTitle, viewMode, imagesWithError = [], onImageChange, onViewModeChange, }) {
    const imageEntires = Object.entries(images);
    const [imageName, setImageName] = (0, react_1.useState)(imageEntires.at(0)?.[0] ?? '');
    const handleImageChange = (name) => {
        setImageName(name);
        onImageChange(name);
    };
    const handleViewModeChange = (mode) => {
        onViewModeChange(mode);
    };
    const error = errorMessage || imagesWithError.includes(imageName) ? (images[imageName]?.error ?? errorMessage) : null;
    return showTitle || error || imageEntires.length > 1 || showViewModes ? (react_1.default.createElement(Container, null,
        showTitle && (react_1.default.createElement(H1, null, title.flatMap((token) => [token, react_1.default.createElement(HeaderDivider, { key: token }, "/")]).slice(0, -1))),
        error && (react_1.default.createElement(ErrorContainer, null,
            react_1.default.createElement(components_1.Icons, { icon: "closeAlt" }),
            react_1.default.createElement("pre", null, error))),
        imageEntires.length > 1 ? (react_1.default.createElement(ImagesEntriesContainer, null, imageEntires.map(([name, image]) => (react_1.default.createElement(ImagePreview_js_1.ImagePreview, { key: name, imageName: name, url: `${(0, helpers_js_1.getImageUrl)(title, name)}/${image.actual}`, isActive: name === imageName, onClick: handleImageChange, error: imagesWithError.includes(name) }))))) : null,
        showViewModes && (react_1.default.createElement(components_1.Tabs, { selected: viewMode, actions: { onSelect: handleViewModeChange } }, viewMode_js_1.viewModes.map((x) => (react_1.default.createElement("div", { key: x, id: x, title: x }))))))) : null;
}
//# sourceMappingURL=PageHeader.js.map