"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TestLink = TestLink;
const react_1 = __importStar(require("react"));
const TestStatusIcon_js_1 = require("./TestStatusIcon.js");
const CreeveyContext_js_1 = require("../../CreeveyContext.js");
const SideBar_js_1 = require("./SideBar.js");
const KeyboardEventsContext_js_1 = require("../../KeyboardEventsContext.js");
const SuiteLink_js_1 = require("./SuiteLink.js");
const Checkbox_js_1 = require("./Checkbox.js");
const helpers_js_1 = require("../../../shared/helpers.js");
function TestLink({ title, opened, test }) {
    const { onSuiteToggle } = (0, react_1.useContext)(CreeveyContext_js_1.CreeveyContext);
    const { onOpenTest } = (0, react_1.useContext)(SideBar_js_1.SideBarContext);
    const { sidebarFocusedItem, setSidebarFocusedItem } = (0, react_1.useContext)(KeyboardEventsContext_js_1.KeyboardEventsContext);
    const buttonRef = (0, react_1.useRef)(null);
    const emptyResults = (test.results?.length ?? 0) == 0;
    const testPath = (0, react_1.useMemo)(() => (0, helpers_js_1.getTestPath)(test), [test]);
    const isTestFocused = (0, react_1.useMemo)(() => Array.isArray(sidebarFocusedItem) &&
        testPath.length === sidebarFocusedItem.length &&
        testPath.every((x) => sidebarFocusedItem.includes(x)), [testPath, sidebarFocusedItem]);
    const handleCheck = (0, react_1.useCallback)((value) => {
        onSuiteToggle(testPath, value);
    }, [testPath, onSuiteToggle]);
    (0, react_1.useEffect)(() => {
        if (isTestFocused)
            buttonRef.current?.focus();
    }, [isTestFocused]);
    const handleOpen = (0, react_1.useCallback)(() => {
        onOpenTest(test);
        setSidebarFocusedItem((0, helpers_js_1.getTestPath)(test));
    }, [test, onOpenTest, setSidebarFocusedItem]);
    return (react_1.default.createElement(SuiteLink_js_1.Container, { disabled: emptyResults },
        react_1.default.createElement(SuiteLink_js_1.Button, { onClick: handleOpen, active: opened, focused: isTestFocused, disabled: emptyResults, ref: buttonRef },
            react_1.default.createElement(TestStatusIcon_js_1.TestStatusIcon, { inverted: opened, status: test.status, skip: test.skip }),
            react_1.default.createElement(SuiteLink_js_1.SuiteContainer, { padding: (testPath.length + 8) * 8 }, title)),
        react_1.default.createElement(Checkbox_js_1.CheckboxContainer, null,
            react_1.default.createElement(Checkbox_js_1.Checkbox, { checked: test.skip ? false : test.checked, disabled: Boolean(test.skip), onValueChange: handleCheck }))));
}
//# sourceMappingURL=TestLink.js.map