"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_dom_1 = __importDefault(require("react-dom"));
const CreeveyApp_js_1 = require("./CreeveyApp.js");
const creeveyClientApi_js_1 = require("../shared/creeveyClientApi.js");
const types_js_1 = require("../../types.js");
const helpers_js_1 = require("../shared/helpers.js");
const CreeveyLoader_js_1 = require("./CreeveyLoader.js");
window.__CREEVEY_SET_READY_FOR_CAPTURE__ = types_js_1.noop;
function loadCreeveyData() {
    return new Promise((resolve) => {
        const script = document.createElement('script');
        script.src = 'data.js';
        script.onload = () => {
            resolve(__CREEVEY_DATA__);
        };
        document.body.appendChild(script);
    });
}
const CreeveyAppAsync = react_1.default.lazy(async () => {
    let isReport = false;
    let creeveyStatus;
    let creeveyApi;
    if (window.location.host) {
        try {
            creeveyApi = await (0, creeveyClientApi_js_1.initCreeveyClientApi)();
            creeveyStatus = await creeveyApi.status;
        }
        catch {
            // NOTE: Failed to get status from API
            // NOTE: It might happen on circle ci from artifact
            isReport = true;
            creeveyStatus = { isRunning: false, tests: await loadCreeveyData(), browsers: [] };
        }
    }
    else {
        isReport = true;
        creeveyStatus = { isRunning: false, tests: await loadCreeveyData(), browsers: [] };
    }
    return {
        default() {
            return (react_1.default.createElement(CreeveyApp_js_1.CreeveyApp, { api: creeveyApi, initialState: { isReport, isRunning: creeveyStatus.isRunning, tests: (0, helpers_js_1.treeifyTests)(creeveyStatus.tests) } }));
        },
    };
});
react_dom_1.default.render(react_1.default.createElement(react_1.Suspense, { fallback: react_1.default.createElement(CreeveyLoader_js_1.CreeveyLoader, null) },
    react_1.default.createElement(CreeveyAppAsync, null)), document.getElementById('root'));
//# sourceMappingURL=index.js.map