import { SkipOptions, SkipOption, TestData, ServerTest } from '../types.js';
export declare const isShuttingDown: {
    current: boolean;
};
export declare const LOCALHOST_REGEXP: RegExp;
export declare const configExt: string[];
export declare const skipOptionKeys: string[];
export declare function shouldSkip(browser: string, meta: {
    title: string;
    name: string;
}, skipOptions: SkipOptions, test?: string): string | boolean;
export declare function shouldSkipByOption(browser: string, meta: {
    title: string;
    name: string;
}, skipOption: SkipOption | SkipOption[], reason: string, test?: string): string | boolean;
export declare function shutdownWorkers(): Promise<void>;
export declare function shutdown(): void;
export declare function getCreeveyCache(): string | undefined;
export declare function runSequence(seq: (() => unknown)[], predicate: () => boolean): Promise<void>;
export declare function testsToImages(tests: (TestData | undefined)[]): Set<string>;
export declare const isInsideDocker: boolean;
export declare const downloadBinary: (downloadUrl: string, destination: string) => Promise<void>;
export declare function readDirRecursive(dirPath: string): string[];
export declare function tryToLoadTestsData(filename: string): Partial<Record<string, ServerTest>> | undefined;
export declare function loadThroughTSX<T>(callback: (load: (modulePath: string) => Promise<T>) => Promise<T>): Promise<T>;
