"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.noop = noop;
exports.isDefined = isDefined;
exports.isTest = isTest;
exports.isObject = isObject;
exports.isString = isString;
exports.isFunction = isFunction;
exports.isImageError = isImageError;
exports.isProcessMessage = isProcessMessage;
exports.isWorkerMessage = isWorkerMessage;
exports.isStoriesMessage = isStoriesMessage;
exports.isTestMessage = isTestMessage;
exports.isWebpackMessage = isWebpackMessage;
exports.isDockerMessage = isDockerMessage;
function noop() {
    /* noop */
}
function isDefined(value) {
    return value !== null && value !== undefined;
}
function isTest(x) {
    return (isDefined(x) &&
        isObject(x) &&
        'id' in x &&
        'storyId' in x &&
        typeof x.id == 'string' &&
        typeof x.storyId == 'string');
}
function isObject(x) {
    return typeof x == 'object' && x != null;
}
function isString(x) {
    return typeof x == 'string';
}
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function isFunction(x) {
    return typeof x == 'function';
}
function isImageError(error) {
    return error instanceof Error && 'images' in error;
}
function isProcessMessage(message) {
    return isObject(message) && 'scope' in message;
}
function isWorkerMessage(message) {
    return isProcessMessage(message) && message.scope == 'worker';
}
function isStoriesMessage(message) {
    return isProcessMessage(message) && message.scope == 'stories';
}
function isTestMessage(message) {
    return isProcessMessage(message) && message.scope == 'test';
}
function isWebpackMessage(message) {
    return isProcessMessage(message) && message.scope == 'webpack';
}
function isDockerMessage(message) {
    return isProcessMessage(message) && message.scope == 'docker';
}
//# sourceMappingURL=types.js.map